/*
 * Please do not edit this file.
 * It was generated using rpcgen.
 */

#ifndef _ICBINN_PROT_H_RPCGEN
#define _ICBINN_PROT_H_RPCGEN

#include <rpc/rpc.h>


#ifdef __cplusplus
extern "C" {
#endif

#define ICBINN_PROT_PORT 4878
#define ICBINN_PROT_MAXPATHLEN 4096
#define ICBINN_PROT_MAXNAMELEN 1024
#define ICBINN_PROT_MAXDATA 16384
#define ICBINN_PROT_FHSIZE 32

typedef char *icbinn_prot_path;

typedef char *icbinn_prot_filename;

typedef int icbinn_prot_fd;

typedef int icbinn_prot_errno;
#define ICBINN_PROT_RDONLY 0
#define ICBINN_PROT_WRONLY 1
#define ICBINN_PROT_RDWR 2
#define ICBINN_PROT_CREAT 0100
#define ICBINN_PROT_TRUNC 01000

enum icbinn_prot_ltype {
	ICBINN_PROT_LTYPE_RDLCK = 0,
	ICBINN_PROT_LTYPE_WRLCK = 1,
	ICBINN_PROT_LTYPE_UNLCK = 2,
};
typedef enum icbinn_prot_ltype icbinn_prot_ltype;

enum icbinn_prot_type {
	ICBINN_PROT_FILE = 0,
	ICBINN_PROT_DIRECTORY = 1,
	ICBINN_PROT_LINK = 2,
	ICBINN_PROT_UNKNOWN = 3,
};
typedef enum icbinn_prot_type icbinn_prot_type;

enum icbinn_prot_randsrc {
	ICBINN_PROT_RANDOM = 0,
	ICBINN_PROT_URANDOM = 1,
};
typedef enum icbinn_prot_randsrc icbinn_prot_randsrc;

enum icbinn_prot_stat {
	ICBINN_PROT_OK = 0,
	ICBINN_PROT_ERROR = 1,
};
typedef enum icbinn_prot_stat icbinn_prot_stat;

struct icbinn_prot_errnostat {
	icbinn_prot_stat status;
	union {
		icbinn_prot_errno errno_code;
	} icbinn_prot_errnostat_u;
};
typedef struct icbinn_prot_errnostat icbinn_prot_errnostat;

struct icbinn_prot_readdirargs {
	icbinn_prot_path dir;
	u_int offset;
	u_int count;
};
typedef struct icbinn_prot_readdirargs icbinn_prot_readdirargs;

struct icbinn_prot_entry {
	icbinn_prot_filename name;
	enum icbinn_prot_type type;
	struct icbinn_prot_entry *nextentry;
};
typedef struct icbinn_prot_entry icbinn_prot_entry;

struct icbinn_prot_dirlist {
	icbinn_prot_entry *entries;
	bool_t eof;
};
typedef struct icbinn_prot_dirlist icbinn_prot_dirlist;

struct icbinn_prot_readdirres {
	icbinn_prot_stat status;
	union {
		icbinn_prot_dirlist reply;
	} icbinn_prot_readdirres_u;
};
typedef struct icbinn_prot_readdirres icbinn_prot_readdirres;

struct icbinn_prot_openargs {
	icbinn_prot_path name;
	int mode;
};
typedef struct icbinn_prot_openargs icbinn_prot_openargs;

struct icbinn_prot_openokres {
	icbinn_prot_fd fd;
};
typedef struct icbinn_prot_openokres icbinn_prot_openokres;

struct icbinn_prot_openres {
	icbinn_prot_stat status;
	union {
		icbinn_prot_openokres reply;
		icbinn_prot_errno errno_code;
	} icbinn_prot_openres_u;
};
typedef struct icbinn_prot_openres icbinn_prot_openres;

struct icbinn_prot_statokres {
	u_quad_t size;
	enum icbinn_prot_type type;
};
typedef struct icbinn_prot_statokres icbinn_prot_statokres;

struct icbinn_prot_statres {
	icbinn_prot_stat status;
	union {
		icbinn_prot_statokres reply;
		icbinn_prot_errno errno_code;
	} icbinn_prot_statres_u;
};
typedef struct icbinn_prot_statres icbinn_prot_statres;

struct icbinn_prot_preadargs {
	icbinn_prot_fd fd;
	u_quad_t offset;
	u_quad_t count;
};
typedef struct icbinn_prot_preadargs icbinn_prot_preadargs;

struct icbinn_prot_preadokres {
	struct {
		u_int data_len;
		char *data_val;
	} data;
};
typedef struct icbinn_prot_preadokres icbinn_prot_preadokres;

struct icbinn_prot_preadres {
	icbinn_prot_stat status;
	union {
		icbinn_prot_preadokres reply;
		icbinn_prot_errno errno_code;
	} icbinn_prot_preadres_u;
};
typedef struct icbinn_prot_preadres icbinn_prot_preadres;

struct icbinn_prot_pwriteargs {
	icbinn_prot_fd fd;
	u_quad_t offset;
	struct {
		u_int data_len;
		char *data_val;
	} data;
};
typedef struct icbinn_prot_pwriteargs icbinn_prot_pwriteargs;

struct icbinn_prot_lockargs {
	icbinn_prot_fd fd;
	icbinn_prot_ltype type;
};
typedef struct icbinn_prot_lockargs icbinn_prot_lockargs;

struct icbinn_prot_renameargs {
	icbinn_prot_path from;
	icbinn_prot_path to;
};
typedef struct icbinn_prot_renameargs icbinn_prot_renameargs;

struct icbinn_prot_ftruncateargs {
	icbinn_prot_fd fd;
	u_quad_t length;
};
typedef struct icbinn_prot_ftruncateargs icbinn_prot_ftruncateargs;

struct icbinn_prot_randargs {
	u_quad_t count;
	enum icbinn_prot_randsrc src;
};
typedef struct icbinn_prot_randargs icbinn_prot_randargs;

struct icbinn_prot_fallocateargs {
	icbinn_prot_fd fd;
	int mode;
	u_quad_t offset;
	u_quad_t length;
};
typedef struct icbinn_prot_fallocateargs icbinn_prot_fallocateargs;

struct icbinn_prot_randokres {
	struct {
		u_int data_len;
		char *data_val;
	} data;
};
typedef struct icbinn_prot_randokres icbinn_prot_randokres;

struct icbinn_prot_symlinkargs {
	icbinn_prot_path oldpath;
	icbinn_prot_path newpath;
};
typedef struct icbinn_prot_symlinkargs icbinn_prot_symlinkargs;

struct icbinn_prot_readlinkargs {
	icbinn_prot_path path;
	u_quad_t bufsz;
};
typedef struct icbinn_prot_readlinkargs icbinn_prot_readlinkargs;

struct icbinn_prot_readlinkokres {
	struct {
		u_int data_len;
		char *data_val;
	} data;
};
typedef struct icbinn_prot_readlinkokres icbinn_prot_readlinkokres;

struct icbinn_prot_readlinkres {
	icbinn_prot_stat status;
	union {
		icbinn_prot_readlinkokres reply;
		icbinn_prot_errno errno_code;
	} icbinn_prot_readlinkres_u;
};
typedef struct icbinn_prot_readlinkres icbinn_prot_readlinkres;

struct icbinn_prot_randres {
	icbinn_prot_stat status;
	union {
		icbinn_prot_randokres reply;
	} icbinn_prot_randres_u;
};
typedef struct icbinn_prot_randres icbinn_prot_randres;

struct icbinn_prot_statfsokres {
	u_quad_t bsize;
	u_quad_t blocks;
	u_quad_t bfree;
	u_quad_t bavail;
};
typedef struct icbinn_prot_statfsokres icbinn_prot_statfsokres;

struct icbinn_prot_statfsres {
	icbinn_prot_stat status;
	union {
		icbinn_prot_statfsokres reply;
		icbinn_prot_errno errno_code;
	} icbinn_prot_statfsres_u;
};
typedef struct icbinn_prot_statfsres icbinn_prot_statfsres;

#define ICBINN_PROT_PROGRAM 1827368391
#define ICBINN_PROT_VERSION 1

#if defined(__STDC__) || defined(__cplusplus)
#define ICBINN_PROT_NULL 0
extern  void * icbinn_prot_null_1(void *, CLIENT *);
extern  void * icbinn_prot_null_1_svc(void *, struct svc_req *);
#define ICBINN_PROT_READDIR 1
extern  icbinn_prot_readdirres * icbinn_prot_readdir_1(icbinn_prot_readdirargs *, CLIENT *);
extern  icbinn_prot_readdirres * icbinn_prot_readdir_1_svc(icbinn_prot_readdirargs *, struct svc_req *);
#define ICBINN_PROT_STAT 2
extern  icbinn_prot_statres * icbinn_prot_stat_1(icbinn_prot_path *, CLIENT *);
extern  icbinn_prot_statres * icbinn_prot_stat_1_svc(icbinn_prot_path *, struct svc_req *);
#define ICBINN_PROT_OPEN 3
extern  icbinn_prot_openres * icbinn_prot_open_1(icbinn_prot_openargs *, CLIENT *);
extern  icbinn_prot_openres * icbinn_prot_open_1_svc(icbinn_prot_openargs *, struct svc_req *);
#define ICBINN_PROT_LOCK 4
extern  icbinn_prot_errnostat * icbinn_prot_lock_1(icbinn_prot_lockargs *, CLIENT *);
extern  icbinn_prot_errnostat * icbinn_prot_lock_1_svc(icbinn_prot_lockargs *, struct svc_req *);
#define ICBINN_PROT_PREAD 5
extern  icbinn_prot_preadres * icbinn_prot_pread_1(icbinn_prot_preadargs *, CLIENT *);
extern  icbinn_prot_preadres * icbinn_prot_pread_1_svc(icbinn_prot_preadargs *, struct svc_req *);
#define ICBINN_PROT_PWRITE 6
extern  icbinn_prot_errnostat * icbinn_prot_pwrite_1(icbinn_prot_pwriteargs *, CLIENT *);
extern  icbinn_prot_errnostat * icbinn_prot_pwrite_1_svc(icbinn_prot_pwriteargs *, struct svc_req *);
#define ICBINN_PROT_CLOSE 7
extern  icbinn_prot_errnostat * icbinn_prot_close_1(icbinn_prot_fd *, CLIENT *);
extern  icbinn_prot_errnostat * icbinn_prot_close_1_svc(icbinn_prot_fd *, struct svc_req *);
#define ICBINN_PROT_MKDIR 8
extern  icbinn_prot_errnostat * icbinn_prot_mkdir_1(icbinn_prot_path *, CLIENT *);
extern  icbinn_prot_errnostat * icbinn_prot_mkdir_1_svc(icbinn_prot_path *, struct svc_req *);
#define ICBINN_PROT_RMDIR 9
extern  icbinn_prot_errnostat * icbinn_prot_rmdir_1(icbinn_prot_path *, CLIENT *);
extern  icbinn_prot_errnostat * icbinn_prot_rmdir_1_svc(icbinn_prot_path *, struct svc_req *);
#define ICBINN_PROT_RENAME 10
extern  icbinn_prot_errnostat * icbinn_prot_rename_1(icbinn_prot_renameargs *, CLIENT *);
extern  icbinn_prot_errnostat * icbinn_prot_rename_1_svc(icbinn_prot_renameargs *, struct svc_req *);
#define ICBINN_PROT_UNLINK 11
extern  icbinn_prot_errnostat * icbinn_prot_unlink_1(icbinn_prot_path *, CLIENT *);
extern  icbinn_prot_errnostat * icbinn_prot_unlink_1_svc(icbinn_prot_path *, struct svc_req *);
#define ICBINN_PROT_FTRUNCATE 12
extern  icbinn_prot_errnostat * icbinn_prot_ftruncate_1(icbinn_prot_ftruncateargs *, CLIENT *);
extern  icbinn_prot_errnostat * icbinn_prot_ftruncate_1_svc(icbinn_prot_ftruncateargs *, struct svc_req *);
#define ICBINN_PROT_RAND 13
extern  icbinn_prot_randres * icbinn_prot_rand_1(icbinn_prot_randargs *, CLIENT *);
extern  icbinn_prot_randres * icbinn_prot_rand_1_svc(icbinn_prot_randargs *, struct svc_req *);
#define ICBINN_PROT_FALLOCATE 14
extern  icbinn_prot_errnostat * icbinn_prot_fallocate_1(icbinn_prot_fallocateargs *, CLIENT *);
extern  icbinn_prot_errnostat * icbinn_prot_fallocate_1_svc(icbinn_prot_fallocateargs *, struct svc_req *);
#define ICBINN_PROT_SYMLINK 15
extern  icbinn_prot_errnostat * icbinn_prot_symlink_1(icbinn_prot_symlinkargs *, CLIENT *);
extern  icbinn_prot_errnostat * icbinn_prot_symlink_1_svc(icbinn_prot_symlinkargs *, struct svc_req *);
#define ICBINN_PROT_READLINK 16
extern  icbinn_prot_readlinkres * icbinn_prot_readlink_1(icbinn_prot_readlinkargs *, CLIENT *);
extern  icbinn_prot_readlinkres * icbinn_prot_readlink_1_svc(icbinn_prot_readlinkargs *, struct svc_req *);
#define ICBINN_PROT_STATFS 17
extern  icbinn_prot_statfsres * icbinn_prot_statfs_1(icbinn_prot_path *, CLIENT *);
extern  icbinn_prot_statfsres * icbinn_prot_statfs_1_svc(icbinn_prot_path *, struct svc_req *);
#define ICBINN_PROT_FSYNC 18
extern  icbinn_prot_errnostat * icbinn_prot_fsync_1(icbinn_prot_fd *, CLIENT *);
extern  icbinn_prot_errnostat * icbinn_prot_fsync_1_svc(icbinn_prot_fd *, struct svc_req *);
extern int icbinn_prot_program_1_freeresult (SVCXPRT *, xdrproc_t, caddr_t);

#else /* K&R C */
#define ICBINN_PROT_NULL 0
extern  void * icbinn_prot_null_1();
extern  void * icbinn_prot_null_1_svc();
#define ICBINN_PROT_READDIR 1
extern  icbinn_prot_readdirres * icbinn_prot_readdir_1();
extern  icbinn_prot_readdirres * icbinn_prot_readdir_1_svc();
#define ICBINN_PROT_STAT 2
extern  icbinn_prot_statres * icbinn_prot_stat_1();
extern  icbinn_prot_statres * icbinn_prot_stat_1_svc();
#define ICBINN_PROT_OPEN 3
extern  icbinn_prot_openres * icbinn_prot_open_1();
extern  icbinn_prot_openres * icbinn_prot_open_1_svc();
#define ICBINN_PROT_LOCK 4
extern  icbinn_prot_errnostat * icbinn_prot_lock_1();
extern  icbinn_prot_errnostat * icbinn_prot_lock_1_svc();
#define ICBINN_PROT_PREAD 5
extern  icbinn_prot_preadres * icbinn_prot_pread_1();
extern  icbinn_prot_preadres * icbinn_prot_pread_1_svc();
#define ICBINN_PROT_PWRITE 6
extern  icbinn_prot_errnostat * icbinn_prot_pwrite_1();
extern  icbinn_prot_errnostat * icbinn_prot_pwrite_1_svc();
#define ICBINN_PROT_CLOSE 7
extern  icbinn_prot_errnostat * icbinn_prot_close_1();
extern  icbinn_prot_errnostat * icbinn_prot_close_1_svc();
#define ICBINN_PROT_MKDIR 8
extern  icbinn_prot_errnostat * icbinn_prot_mkdir_1();
extern  icbinn_prot_errnostat * icbinn_prot_mkdir_1_svc();
#define ICBINN_PROT_RMDIR 9
extern  icbinn_prot_errnostat * icbinn_prot_rmdir_1();
extern  icbinn_prot_errnostat * icbinn_prot_rmdir_1_svc();
#define ICBINN_PROT_RENAME 10
extern  icbinn_prot_errnostat * icbinn_prot_rename_1();
extern  icbinn_prot_errnostat * icbinn_prot_rename_1_svc();
#define ICBINN_PROT_UNLINK 11
extern  icbinn_prot_errnostat * icbinn_prot_unlink_1();
extern  icbinn_prot_errnostat * icbinn_prot_unlink_1_svc();
#define ICBINN_PROT_FTRUNCATE 12
extern  icbinn_prot_errnostat * icbinn_prot_ftruncate_1();
extern  icbinn_prot_errnostat * icbinn_prot_ftruncate_1_svc();
#define ICBINN_PROT_RAND 13
extern  icbinn_prot_randres * icbinn_prot_rand_1();
extern  icbinn_prot_randres * icbinn_prot_rand_1_svc();
#define ICBINN_PROT_FALLOCATE 14
extern  icbinn_prot_errnostat * icbinn_prot_fallocate_1();
extern  icbinn_prot_errnostat * icbinn_prot_fallocate_1_svc();
#define ICBINN_PROT_SYMLINK 15
extern  icbinn_prot_errnostat * icbinn_prot_symlink_1();
extern  icbinn_prot_errnostat * icbinn_prot_symlink_1_svc();
#define ICBINN_PROT_READLINK 16
extern  icbinn_prot_readlinkres * icbinn_prot_readlink_1();
extern  icbinn_prot_readlinkres * icbinn_prot_readlink_1_svc();
#define ICBINN_PROT_STATFS 17
extern  icbinn_prot_statfsres * icbinn_prot_statfs_1();
extern  icbinn_prot_statfsres * icbinn_prot_statfs_1_svc();
#define ICBINN_PROT_FSYNC 18
extern  icbinn_prot_errnostat * icbinn_prot_fsync_1();
extern  icbinn_prot_errnostat * icbinn_prot_fsync_1_svc();
extern int icbinn_prot_program_1_freeresult ();
#endif /* K&R C */

/* the xdr functions */

#if defined(__STDC__) || defined(__cplusplus)
extern  bool_t xdr_icbinn_prot_path (XDR *, icbinn_prot_path*);
extern  bool_t xdr_icbinn_prot_filename (XDR *, icbinn_prot_filename*);
extern  bool_t xdr_icbinn_prot_fd (XDR *, icbinn_prot_fd*);
extern  bool_t xdr_icbinn_prot_errno (XDR *, icbinn_prot_errno*);
extern  bool_t xdr_icbinn_prot_ltype (XDR *, icbinn_prot_ltype*);
extern  bool_t xdr_icbinn_prot_type (XDR *, icbinn_prot_type*);
extern  bool_t xdr_icbinn_prot_randsrc (XDR *, icbinn_prot_randsrc*);
extern  bool_t xdr_icbinn_prot_stat (XDR *, icbinn_prot_stat*);
extern  bool_t xdr_icbinn_prot_errnostat (XDR *, icbinn_prot_errnostat*);
extern  bool_t xdr_icbinn_prot_readdirargs (XDR *, icbinn_prot_readdirargs*);
extern  bool_t xdr_icbinn_prot_entry (XDR *, icbinn_prot_entry*);
extern  bool_t xdr_icbinn_prot_dirlist (XDR *, icbinn_prot_dirlist*);
extern  bool_t xdr_icbinn_prot_readdirres (XDR *, icbinn_prot_readdirres*);
extern  bool_t xdr_icbinn_prot_openargs (XDR *, icbinn_prot_openargs*);
extern  bool_t xdr_icbinn_prot_openokres (XDR *, icbinn_prot_openokres*);
extern  bool_t xdr_icbinn_prot_openres (XDR *, icbinn_prot_openres*);
extern  bool_t xdr_icbinn_prot_statokres (XDR *, icbinn_prot_statokres*);
extern  bool_t xdr_icbinn_prot_statres (XDR *, icbinn_prot_statres*);
extern  bool_t xdr_icbinn_prot_preadargs (XDR *, icbinn_prot_preadargs*);
extern  bool_t xdr_icbinn_prot_preadokres (XDR *, icbinn_prot_preadokres*);
extern  bool_t xdr_icbinn_prot_preadres (XDR *, icbinn_prot_preadres*);
extern  bool_t xdr_icbinn_prot_pwriteargs (XDR *, icbinn_prot_pwriteargs*);
extern  bool_t xdr_icbinn_prot_lockargs (XDR *, icbinn_prot_lockargs*);
extern  bool_t xdr_icbinn_prot_renameargs (XDR *, icbinn_prot_renameargs*);
extern  bool_t xdr_icbinn_prot_ftruncateargs (XDR *, icbinn_prot_ftruncateargs*);
extern  bool_t xdr_icbinn_prot_randargs (XDR *, icbinn_prot_randargs*);
extern  bool_t xdr_icbinn_prot_fallocateargs (XDR *, icbinn_prot_fallocateargs*);
extern  bool_t xdr_icbinn_prot_randokres (XDR *, icbinn_prot_randokres*);
extern  bool_t xdr_icbinn_prot_symlinkargs (XDR *, icbinn_prot_symlinkargs*);
extern  bool_t xdr_icbinn_prot_readlinkargs (XDR *, icbinn_prot_readlinkargs*);
extern  bool_t xdr_icbinn_prot_readlinkokres (XDR *, icbinn_prot_readlinkokres*);
extern  bool_t xdr_icbinn_prot_readlinkres (XDR *, icbinn_prot_readlinkres*);
extern  bool_t xdr_icbinn_prot_randres (XDR *, icbinn_prot_randres*);
extern  bool_t xdr_icbinn_prot_statfsokres (XDR *, icbinn_prot_statfsokres*);
extern  bool_t xdr_icbinn_prot_statfsres (XDR *, icbinn_prot_statfsres*);

#else /* K&R C */
extern bool_t xdr_icbinn_prot_path ();
extern bool_t xdr_icbinn_prot_filename ();
extern bool_t xdr_icbinn_prot_fd ();
extern bool_t xdr_icbinn_prot_errno ();
extern bool_t xdr_icbinn_prot_ltype ();
extern bool_t xdr_icbinn_prot_type ();
extern bool_t xdr_icbinn_prot_randsrc ();
extern bool_t xdr_icbinn_prot_stat ();
extern bool_t xdr_icbinn_prot_errnostat ();
extern bool_t xdr_icbinn_prot_readdirargs ();
extern bool_t xdr_icbinn_prot_entry ();
extern bool_t xdr_icbinn_prot_dirlist ();
extern bool_t xdr_icbinn_prot_readdirres ();
extern bool_t xdr_icbinn_prot_openargs ();
extern bool_t xdr_icbinn_prot_openokres ();
extern bool_t xdr_icbinn_prot_openres ();
extern bool_t xdr_icbinn_prot_statokres ();
extern bool_t xdr_icbinn_prot_statres ();
extern bool_t xdr_icbinn_prot_preadargs ();
extern bool_t xdr_icbinn_prot_preadokres ();
extern bool_t xdr_icbinn_prot_preadres ();
extern bool_t xdr_icbinn_prot_pwriteargs ();
extern bool_t xdr_icbinn_prot_lockargs ();
extern bool_t xdr_icbinn_prot_renameargs ();
extern bool_t xdr_icbinn_prot_ftruncateargs ();
extern bool_t xdr_icbinn_prot_randargs ();
extern bool_t xdr_icbinn_prot_fallocateargs ();
extern bool_t xdr_icbinn_prot_randokres ();
extern bool_t xdr_icbinn_prot_symlinkargs ();
extern bool_t xdr_icbinn_prot_readlinkargs ();
extern bool_t xdr_icbinn_prot_readlinkokres ();
extern bool_t xdr_icbinn_prot_readlinkres ();
extern bool_t xdr_icbinn_prot_randres ();
extern bool_t xdr_icbinn_prot_statfsokres ();
extern bool_t xdr_icbinn_prot_statfsres ();

#endif /* K&R C */

#ifdef __cplusplus
}
#endif

#endif /* !_ICBINN_PROT_H_RPCGEN */
