/*
 * icbinn.h.in:
 *
 *
 */

/*
 * $Id:$
 */

/*
 * $Log:$
 *
 */

/* MAKE ABSOLUTELY SURE THAT YOU ARE EDITING THE icbinn-head.h.in */
/* FILE FROM WHICH THIS IS GENERATED - OTHERWISE YOUR EDITS */
/* WILL BE LOST */

#ifndef __ICBINN_H__
#define __ICBINN_H__

#ifdef __cplusplus
extern "C" { 
#endif

#include <stdio.h>

/*the integer constants here are set by configure*/

/*get uint32_t and friends defined */
#if 1
#include <stdint.h>
#elif 0
#include <sys/int_types.h>
#endif
#if 1
#include <unistd.h>
#endif

/* If the following is <> then configure failed to find where */
/* struct tm was defined - report it as a bug */

/*get struct tm defined*/
#include <time.h>



#define ICBINN_PORT 4878
#define ICBINN_MAXPATHLEN 4096
#define ICBINN_MAXNAMELEN 1024
#define ICBINN_MAXDATA 16384
#define ICBINN_FHSIZE 32

#define ICBINN_RDONLY 0
#define ICBINN_WRONLY 1
#define ICBINN_RDWR 2

#define ICBINN_CREAT 0100
#define ICBINN_TRUNC 01000

/* FIXME: test these match */
#define ICBINN_LTYPE_RDLCK 0
#define ICBINN_LTYPE_WRLCK 1
#define ICBINN_LTYPE_UNLCK 2


#define ICBINN_TYPE_FILE 0
#define ICBINN_TYPE_DIRECTORY 1
#define ICBINN_TYPE_LINK 2
#define ICBINN_TYPE_UNKNOWN 3

#define ICBINN_RANDOM 0
#define ICBINN_URANDOM 1

struct ICBINN_struct;

typedef struct ICBINN_struct ICBINN;

struct icbinn_stat {
	uint64_t size;
	int type;
};

struct icbinn_statfs {
	uint64_t bsize;
	uint64_t blocks;
	uint64_t bfree;
	uint64_t bavail;
};

struct icbinn_dirent
{
  char name[ICBINN_MAXNAMELEN + 1];
  int type;
};



/*
 * Copyright (c) 2013 Citrix Systems, Inc.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

/* client.c */
ICBINN *icbinn_clnt_create_tcp(const char *host, int port);
ICBINN *icbinn_clnt_create_argo(int domid, int port);
void icbinn_clnt_destroy(ICBINN *icb);
/* close.c */
int icbinn_close(ICBINN *icb, int fd);
/* lock.c */
int icbinn_lock(ICBINN *icb, int fd, int type);
/* mkdir.c */
int icbinn_mkdir(ICBINN *icb, const char *path);
/* null.c */
int icbinn_null(ICBINN *icb);
/* open.c */
int icbinn_open(ICBINN *icb, const char *name, int mode);
/* pread.c */
ssize_t icbinn_pread(ICBINN *icb, int fd, void *_buf, size_t count, uint64_t offset);
/* pwrite.c */
ssize_t icbinn_pwrite(ICBINN *icb, int fd, const void *_buf, size_t count, uint64_t offset);
/* readdir.c */
ssize_t icbinn_readdir(ICBINN *icb, const char *dir, size_t offset, size_t count, struct icbinn_dirent *buf);
int icbinn_readent(ICBINN *icb, const char *dir, size_t offset, struct icbinn_dirent *buf);
/* rename.c */
int icbinn_rename(ICBINN *icb, const char *from, const char *to);
/* rmdir.c */
int icbinn_rmdir(ICBINN *icb, const char *path);
/* stat.c */
int icbinn_stat(ICBINN *icb, const char *path, struct icbinn_stat *buf);
/* unlink.c */
int icbinn_unlink(ICBINN *icb, const char *path);
/* util.c */
/* version.c */
/* ftruncate.c */
int icbinn_ftruncate(ICBINN *icb, int fd, uint64_t length);
/* fallocate.c */
int icbinn_fallocate(ICBINN *icb, int fd, int mode, uint64_t offset, uint64_t length);
/* rand.c */
ssize_t icbinn_rand(ICBINN *icb, int src, void *_buf, size_t count);
/* readlink.c */
ssize_t icbinn_readlink(ICBINN *icb, const char *path, char *buf, size_t bufsz);
/* symlink.c */
int icbinn_symlink(ICBINN *icb, const char *oldpath, const char *newpath);
/* statfs.c */
int icbinn_statfs(ICBINN *icb, const char *path, struct icbinn_statfs *buf);
/* fsync.c */
int icbinn_fsync(ICBINN *icb, int fd);
/* canary.c */
/*
 * Copyright (c) 2012 Citrix Systems, Inc.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifdef __cplusplus
}
#endif

#endif /* __ICBINN_H__ */
